uses crt, dos;

type
  data = array[0..64000] of byte;

var
  out, out2, out3 : file;
  n, bp, p, count : byte;
  fsize, maxx, maxnum, z, start,
  error, num, w, x, i, bpos : word;
  id, size, fpos, l, time : longint;
  buf : ^data;
  b : array[0..23] of byte;
  times : array[8..255] of longint;
  pos : longint;
  code : integer;

function tohex(x : longint) : string;
  const hex : array[0..15] of char = ('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F');
  var st : string;
  begin
    st := '';
    repeat
      st := hex[x and 15]+st;
      x := x shr 4;
    until x = 0;
    if length(st) = 1 then
      st := '0'+st;
    tohex := st;
  end;

begin
  new(buf);
  count := 0;

  {$I-}
  MkDir('comp');
  id := ioresult;
  {$I+}

  {$I-}
  assign(out, 'compinfo.dat');
  reset(out, 1);
  if ioresult = 0 then
    begin
      for id := $08 to $FF do
        blockread(out, times[id], 4);
      close(out);
    end
  else
    for id := $08 to $FF do
      times[id] := 0;
  {$I+}

  assign(out, 'wpj.smc');
  reset(out, 1);
  if paramcount < 1 then
    begin
      write('Too few parameters.');
      halt;
    end;
  val(paramstr(1), pos, code);
  seek(out, pos);
  for id := $08 to $FF do
    begin
      assign(out2, 'wpj\wpj'+tohex(id)+'.dat');
      reset(out2, 1);
      fsize := filesize(out2);
      getftime(out2, time);

      if fsize <> 0 then
        begin
          if time <> times[id] then
            begin
              (* create new compressed file *)
              count := count+1;
              assign(out3, 'comp\comp'+tohex(id)+'.dat');
              rewrite(out3, 1);

              fillchar(buf^, sizeof(buf^), 0);
              blockread(out2, buf^, fsize);
              size := 0;
              bpos := 0; bp := 0;
              n := 0; p := 0;
              while ((bpos < fsize) or (p <> 0)) do
                begin
                  if bpos < 4096 then
                    start := bpos
                  else start := 4096;
                  maxnum := 0;
                  for x := 1 to start do
                    begin
                      num := 0;
                      while (num < 15+255+3) and (buf^[bpos-x+num] = buf^[bpos+num]) and (bpos+num < fsize) do
                        num := num+1;
                      if num > maxnum then
                        begin
                          maxnum := num;
                          maxx := x;
                        end;
                    end;
                  if maxnum >= 3 then
                    begin
                      if maxnum-3 < 15 then
                        begin
                          w := (maxnum-3) shl 12+(maxx-1);
                          b[bp] := lo(w);
                          b[bp+1] := hi(w);
                        end
                      else
                        begin
                          w := (15) shl 12+(maxx-1);
                          b[bp] := lo(w);
                          b[bp+1] := hi(w);
                          b[bp+2] := (maxnum-3)-15;
                          bp := bp+1;
                        end;
                      bp := bp+2;
                      bpos := bpos+maxnum;
                    end
                  else begin
                    n := n or (1 shl p);
                    b[bp] := buf^[bpos];
                    bp := bp+1;
                    bpos := bpos+1;
                  end;
                  p := (p+1) and 7;
                  if p = 0 then
                    begin
                      blockwrite(out3, n, 1);
                      blockwrite(out3, b, bp);
                      size := size+bp+1;
                      n := 0;
                      bp := 0;
                    end;
                end;
              writeln('Size of comp'+tohex(id)+'.dat: ',size);
              getftime(out2, times[id]);
              close(out3);
            end;

          (* insert compressed file *)
          fpos := filepos(out);
          l := fpos+$C00000-$200;
          seek(out, id*4+$2D716);
          blockwrite(out, l, 3);

          seek(out, fpos);
          n := 131;
          blockwrite(out, n, 1);
          blockwrite(out, fsize, 2);

          assign(out3, 'comp\comp'+tohex(id)+'.dat');
          reset(out3, 1);
          fsize := filesize(out3);
          blockread(out3, buf^, fsize);
          blockwrite(out, buf^, fsize);
          close(out3);
        end;
      close(out2);
    end;
  fpos := filepos(out);
  writeln('Final compressed size: ', fpos-pos, ' of ', $2E914D-pos);
  writeln('Space left: ', $2E914D-fpos);
  if fpos > $2E914D then
    writeln('Compressed data too big!!!!!!!!!!!!!!!!');
  close(out);

  assign(out, 'compinfo.dat');
  rewrite(out, 1);
  for id := $08 to $FF do
    begin
      blockwrite(out, times[id], 4);
    end;
  close(out);
  dispose(buf);

  writeln(count, ' files updated.');
end.
