uses crt;

var
  fp1 : file;
  fp2 : text;
  i, j, code : integer;
  b : byte;
  c : char;
  pos : longint;
  st, st1 : string;
  widths : array[1..66] of byte;
  mask : byte;

function convert(st : string) : string;
var
  j : integer;
  st1 : string;

begin
  st1 := '';
  for j := 1 to 15 do
    begin
      if j <= length(st) then
        begin
          b := ord(st[j])+1;
          case st[j] of
            'A'..'Z' : b := b-ord('A');
            'a'..'z' : b := b-ord('a')+26;
            '1'..'9' : b := b-ord('0')+51;
            '0' : b := 31;
            '.' : b := 62;
            '-' : b := 63;
            '''' : b := 64;
            '!' : b := 65;
          else
            b := 66;
          end;
        end
      else b := 0;
      st1 := st1+chr(b);
    end;
  convert := st1;
end;

function findwidth(st : string) : byte;
var
  j : integer;
  width : byte;

begin
  width := 0;
  for j := 1 to 15 do
    begin
      if (ord(st[j]) <> 0) then
        width := width+widths[ord(st[j])];
    end;
  if width <> 0 then
    findwidth := width-1
  else findwidth := 0;
end;

begin
  assign(fp1, 'wpj.smc');
  reset(fp1, 1);
  assign(fp2, 'wpjitems.txt');
  reset(fp2);
  if paramcount < 2 then
    begin
      write('Too few parameters.');
      halt;
    end;
  val(paramstr(1), pos, code);
  seek(fp1, pos);

  for i := 1 to 65 do
    begin
      mask := 0;
      for j := 1 to 8 do
        begin
          blockread(fp1, b, 1);
          mask := mask or b;
        end;
      j := 0;
      while ((((mask shr j) and 1) = 0) and (j <> 8)) do
        begin j := j+1; end;
      widths[i] := 8-j+1;
    end;
  widths[66] := 4;

  val(paramstr(2), pos, code);
  seek(fp1, pos);

  {First item is blank}
  b := 32;
  blockwrite(fp1, b, 1);
  b := 0;
  for j := 1 to 15 do
    blockwrite(fp1, b, 1);

  {Read the rest of the items}
  for i := 1 to 69 do
    begin
      readln(fp2, st1);
      st := convert(st1);
      b := (64-findwidth(st)) div 2;
      blockwrite(fp1, b, 1);
      for j := 1 to 15 do
        begin
          b := ord(st[j]);
          blockwrite(fp1, b, 1);
        end;
    end;

  close(fp1);
  close(fp2);
end.