uses crt;

const
  engsize = 1024;

type
  engrec = record
    size : integer;
    st : array[0..engsize-1] of byte;
  end;

var
  n, page : longint;
  count : word;
  engfp1, engfp2, mergefp : file;
  engtext1, engtext2 : engrec;
  diff : boolean;
  ch : char;

function tohex(x : longint) : string;
  const hex : array[0..15] of char = ('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F');
  var
    n : integer;
    st : string;
  begin
    st := '';
    for n := 1 to 2 do
      begin
        st := hex[x and 15]+st;
        x := x shr 4;
      end;
    tohex := st;
  end;

function chartokb(c : byte) : string;
begin
  case c of
    2 : chartokb := #13#10;
    6 : chartokb := '[Player]';
    7 : chartokb := '[Pino]';
    9 : chartokb := '[Number]';
    16..31 : chartokb := chr(c+16);
    32..38 : chartokb := chr(c+26);
    39..44 : chartokb := chr(c+52);
    45..48 : chartokb := chr(c+78);
    49..50 : chartokb := '"';
    51 : chartokb := '...';
    52 : chartokb := '[Heart]';
    53 : chartokb := '[Star]';
    54 : chartokb := '[Circle]';
    55 : chartokb := '[Triangle]';
    56 : chartokb := '[Note]';
    57..66 : chartokb := chr(c-9);
    67..92 : chartokb := chr(c-2);
    93..118 : chartokb := chr(c+4);
  else
    chartokb := '<$'+tohex(c)+'>';
  end;
end;

begin
  assign(mergefp, 'merged.dat');
  rewrite(mergefp, 1);

  filemode := 0;
  assign(engfp1, paramstr(1));
  reset(engfp1, 1);
  blockread(engfp1, count, sizeof(count));
  assign(engfp2, paramstr(2));
  reset(engfp2, 1);
  blockread(engfp2, count, sizeof(count));

  blockwrite(mergefp, count, sizeof(count));

  page := 0;
  repeat
    blockread(engfp1, engtext1, sizeof(engtext1));
    blockread(engfp2, engtext2, sizeof(engtext2));

    if (engtext1.size = 0) and (engtext2.size > 0) then
      ch := '2'
    else if (engtext2.size = 0) and (engtext1.size > 0) then
      ch := '1'
    else begin
      diff := engtext1.size <> engtext2.size;
      if not diff then
        for n := 0 to engtext1.size-1 do
          if engtext1.st[n] <> engtext2.st[n] then
            begin
              diff := true;
              break;
            end;
      ch := '1';
      if diff then
        begin
          clrscr;
          writeln('Difference found on page ', page);
          writeln;
          writeln('Option 1');
          if engtext1.st[0] and 128 <> 0 then write('<$08>');
          for n := 0 to engtext1.size-1 do
            begin
              if (n > 0) and (engtext1.st[n-1] and 128 <> engtext1.st[n] and 128) then
                write('<$08>');
              write(chartokb(engtext1.st[n] and 127));
            end;
          if engtext1.st[engtext1.size-1] and 128 <> 0 then write('<$08>');
          writeln; writeln;
          writeln('Option 2');
          if engtext2.st[0] and 128 <> 0 then write('<$08>');
          for n := 0 to engtext2.size-1 do
            begin
              if (n > 0) and (engtext2.st[n-1] and 128 <> engtext2.st[n] and 128) then
                write('<$08>');
              write(chartokb(engtext2.st[n] and 127));
            end;
          if engtext2.st[engtext2.size-1] and 128 <> 0 then write('<$08>');
          writeln; writeln;
          write('Choose 1 or 2: ');
          repeat
            repeat until keypressed;
            ch := readkey;
          until ch in ['1', '2'];
        end;
    end;
    if ch = '1' then
      blockwrite(mergefp, engtext1, sizeof(engtext1))
    else blockwrite(mergefp, engtext2, sizeof(engtext2));
    inc(page);
  until eof(engfp1);

  close(mergefp);
  close(engfp1);
  close(engfp2);
end.