uses crt;

const
  engsize = 1024;

type
  engrec = record
    size : integer;
    st : array[0..engsize-1] of byte;
  end;

var
  n, page : longint;
  count : word;
  x, code : integer;
  engfp : file;
  line : string;
  engtext : engrec;
  txt : text;
  dark : boolean;

function toupper(st : string) : string;
  var n : integer;
  begin
    for n := 1 to length(st) do
      st[n] := upcase(st[n]);
    toupper := st;
  end;

procedure replace(var st : string; search, replace : string);
  begin
    while pos(search, st) <> 0 do
      st := copy(st, 1, pos(search, st)-1)+replace+copy(st, pos(search, st)+length(search), length(st));
  end;

function todat(c : byte) : byte;
begin
  case c of
    32..33, 35..38, 40..47 : todat := c-16;
    48..57 : todat := c+9;
    58..64 : todat := c-26;
    65..90 : todat := c+2;
    91..95 : todat := c-52;
    97..122 : todat := c-4;
    123..126 : todat := c-78;

    133 : todat := 51;
    145 : todat := 44;
    146 : todat := 23;
    147 : todat := 49;
    148 : todat := 50;

    150 : todat := 6;
    151 : todat := 7;
    152 : todat := 8;
    153 : todat := 9;
    154 : todat := 52;
    155 : todat := 53;
    156 : todat := 54;
    157 : todat := 55;
    158 : todat := 56;
  else
    writeln('Bad character in text file');
  end;
end;

begin
  assign(txt, paramstr(1));
  reset(txt);

  assign(engfp, 'engdump.dat');
  rewrite(engfp, 1);

  repeat
    readln(txt, line);
    line := toupper(line);
  until pos('--COUNT', line) = 1;

  line := copy(line, 9, sizeof(line));
  line := copy(line, 1, pos('--', line)-1);
  val(line, count, code);

  blockwrite(engfp, count, sizeof(count));

  repeat
    readln(txt, line);
    line := toupper(line);
  until (pos('--PAGE', line) = 1) or (pos('--END', line) = 1);
  if pos('--PAGE', line) = 1 then
    begin
      line := copy(line, 8, sizeof(line));
      line := copy(line, 1, pos('--', line)-1);
      val(line, page, code);
    end;

  for n := 0 to count-1 do
    begin
      fillchar(engtext, sizeof(engtext), 0);

      if page = n then
        begin
          dark := false;
          readln(txt, line);
          while (pos('--PAGE', toupper(line)) <> 1) and (pos('--END', toupper(line)) <> 1) do
            begin
              replace(line, '[Player]', #150);
              replace(line, '[Pino]', #151);
              replace(line, '[8]', #152);
              replace(line, '[Number]', #153);
              replace(line, '[Heart]', #154);
              replace(line, '[Star]', #155);
              replace(line, '[Circle]', #156);
              replace(line, '[Triangle]', #157);
              replace(line, '[Note]', #158);
              for x := 1 to length(line) do
                begin
                  if line[x] = #152 then
                    dark := not dark
                  else begin
                    engtext.st[engtext.size] := todat(ord(line[x]))+ord(dark)*128;
                    inc(engtext.size, 1);
                  end;
                end;
              engtext.st[engtext.size] := 2;
              inc(engtext.size, 1);

              readln(txt, line);
            end;

          if pos('--PAGE', toupper(line)) = 1 then
            begin
              line := copy(line, 8, sizeof(line));
              line := copy(line, 1, pos('--', line)-1);
              val(line, page, code);
            end;
        end;
      while (engtext.size > 0) and (engtext.st[engtext.size-1] = 2) do
        begin
          engtext.st[engtext.size-1] := 0;
          dec(engtext.size, 1);
        end;
      blockwrite(engfp, engtext, sizeof(engtext));
    end;

  close(engfp);
  close(txt);
end.